##############################################################################
#
# Copyright (C) 1998 Daniel Lopez
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.



proc ReadCnfScope { scp } {

global com

if [expr [string compare $com(globals,scope,$scp,status) enabled] == 0] {

for "set i 0" {$i < [llength $com(layout,scope,$scp,part,list)]} "incr i" {

	ReadCnfPart $scp $i

	}

}
}


proc ReadCnfPart {  scope part } {

global com

	foreach object $com(containers,$scope.$part,childs,list) {

	foreach pair  $object {

		set module [lindex $pair 0] 
		set directive [lindex $pair 1] 



	set directorio $com(globals,$scope,dir)
	set vhost $com(globals,$scope,vhost)
	set location $com(globals,$scope,location)



	set com(localcfg,service,httpd,context,$vhost,$directorio,$location,$directive) ""
	set com(localcfg,service,httpd,context,$vhost,$directorio,$location,$directive) "[ReadCnfContainer $scope $part $module $directive]"

	}


	}


}

proc ReadCnfContainer { scope part module directive } {

global com
global widget

set temp $scope

append temp _cv

set path $widget($temp).p_$part
 
switch $com(modules,$module,drctvs,$directive,type) {

File -
Directory -
Number -
Email -
Address -
String  {

#"mirar si unset"

	regsub -all {\"} "[$path.dir_$directive.entry get]" {\"} kk
	return "\{$kk\}"

		}
Boolean { 

if "[ string compare  $com(globals,choice,$path.dir_$directive)  UNSET] !=0" \
"return  $com(globals,choice,$path.dir_$directive)"    else {return "{}"}


}

Boolean2 { 

if " $com(globals,checkbuttons,$path.dir_$directive)  == 1 "  {return  " " }  \
else {return "{}"}



}

List {

return  "[$path.dir_$directive.frm.lb get 0 end]"
}

unknown {

return  "[string trimright [$path.dir_$directive.text get 0.0 end]]"
}

List2 {

return  "[$path.dir_$directive.frm.lb get 0 end]"
}

Choice {

if "[ string compare  $com(globals,choice,$path.dir_$directive)  UNSET] !=0" \
"return  $com(globals,choice,$path.dir_$directive)"    else {return "{}"}

}
default {return kk}



}
}

proc FillCnfScope { scp } {

global com

for "set i 0" {$i < [llength $com(layout,scope,$scp,part,list)]} "incr i" {

	FillCnfPart $scp $i

	}


}


proc FillCnfPart {  scope part } {

global com

	foreach object $com(containers,$scope.$part,childs,list) {

	foreach pair  $object {

		set module [lindex $pair 0] 
		set directive [lindex $pair 1] 

	 FillCnfContainer $scope $part $module $directive 


			}


	}


}

proc FillCnfContainer { scope part module directive } {

global com
global widget

set directorio $com(globals,$scope,dir)
set vhost $com(globals,$scope,vhost)
set location $com(globals,$scope,location)

set temp $scope

append temp _cv

set path $widget($temp).p_$part


 
switch $com(modules,$module,drctvs,$directive,type) {

File -
Directory -
Number -
Email -
Address -
String  {

		$path.dir_$directive.entry delete 0 end
		$path.dir_$directive.entry insert 0 [join [join $com(localcfg,service,httpd,context,$vhost,$directorio,$location,$directive)]]

		}
Boolean {
set com(globals,choice,$path.dir_$directive) $com(localcfg,service,httpd,context,$vhost,$directorio,$location,$directive) 

if "[ string compare $com(localcfg,service,httpd,context,$vhost,$directorio,$location,$directive)  {}] == 0" "set com(globals,choice,$path.dir_$directive) UNSET" 
}

Boolean2 {

if [ string compare $com(localcfg,service,httpd,context,$vhost,$directorio,$location,$directive)  on]  "set com(globals,checkbuttons,$path.dir_$directive) 0"  \
   else "set com(globals,checkbuttons,$path.dir_$directive) 1	" 

}



List {
	$path.dir_$directive.frm.lb delete 0 end
	foreach element $com(localcfg,service,httpd,context,$vhost,$directorio,$location,$directive) {

	$path.dir_$directive.frm.lb insert end $element	  
	
	}

}

unknown {

	$path.dir_$directive.text delete 0.0 end
	$path.dir_$directive.text  insert 0.0 $com(localcfg,service,httpd,context,$vhost,$directorio,$location,unknown)
}

List2 {
	$path.dir_$directive.frm.lb delete 0 end
	foreach element $com(localcfg,service,httpd,context,$vhost,$directorio,$location,$directive) {

	$path.dir_$directive.frm.lb insert end $element	  
	
	}

}

Choice {

set com(globals,choice,$path.dir_$directive) $com(localcfg,service,httpd,context,$vhost,$directorio,$location,$directive) 

if "[ string compare $com(localcfg,service,httpd,context,$vhost,$directorio,$location,$directive)  {}] == 0" "set com(globals,choice,$path.dir_$directive) UNSET" 




}

default {return kk}



}


}




proc ClearCnfScope { scp } {

global com

for "set i 0" {$i < [llength $com(layout,scope,$scp,part,list)]} "incr i" {

	ClearCnfPart $scp $i

	}


}


proc ClearCnfPart {  scope part } {

global com

	foreach object $com(containers,$scope.$part,childs,list) {

	foreach pair  $object {

		set module [lindex $pair 0] 
		set directive [lindex $pair 1] 

# Habra que anadir  que cuando parsee los .conf, al encontrarse un directorio inicialice todo a cero

	set directorio $com(globals,$scope,dir)
	set vhost $com(globals,$scope,vhost)
	set location $com(globals,$scope,location)
	

	set com(localcfg,service,httpd,context,$vhost,$directorio,$location,$directive) ""
 

			}


	}


}


proc CnfFilesParser {file}  {


global com

set directorio ""
set vhost ""
set location ""

set fich [open $file]


while {[expr ![eof $fich]]} {

	gets $fich dato

# Quitamos los comentarios

if {[regexp "^ *#+" $dato] || [regexp "^ *$" $dato]} {} else {

# Lo siguiente es por un problema que tiene el tcl con >"

	if [regexp "^ *<+.*>+$" $dato] {
				set olddato $dato
				set dato [lindex [split $dato >] 0]


				switch [string tolower [lindex $dato 0]] {

					"<directory" { 

					set directorio [lindex  $dato 1]
					Create.dir $vhost $directorio				
					}
	
					"</directory" {set directorio ""}

					"<location" { 

					set location [lindex  $dato 1]
					Create.location $vhost	$location
					}
	
					"</location" {set location ""}

					"<virtualhost" { 

					set vhost [lindex  $dato 1]
					set vhost [Create.vhost $vhost]
					}
	
					"</virtualhost" {set vhost ""}
					
					default {
					append com(localcfg,service,httpd,context,$vhost,$directorio,$location,unknown) "$olddato \n"
					}
		

				}
	
	} else {
		


				set kk ""
				regsub -all {\"} $dato {\"} kk
				set dato $kk

			
				set fdato [string tolower [lindex $dato 0]]
				
				set type_dir UNKNOWN				
				
				foreach type { List List2 String File Directory Number Boolean Boolean2 Email Choice Address } {
				
				set result [lsearch -exact $com(dir-types-lowercase,$type) $fdato]
				if [expr $result != -1] { set directive [lindex $com(dir-types,$type) $result] ; set type_dir $type;
							break}
				}
				
				switch $type_dir {
				File -
				Directory -
				Number -
				Email -
				Address -
				String  {
					lappend com(localcfg,service,httpd,list) $vhost,$directorio,$location,$directive
					set kk ""
					regsub -all {\\\"} $dato {\"} kk
					set tmp [string trim  [string range [string trim $kk] [string length $fdato] end ]]
					lappend com(localcfg,service,httpd,context,$vhost,$directorio,$location,$directive) $tmp;

					}

				Boolean { 
				lappend com(localcfg,service,httpd,list) $vhost,$directorio,$location,$directive
				set com(localcfg,service,httpd,context,$vhost,$directorio,$location,$directive)  [string tolower [lrange $dato 1 end]]

				}

				Boolean2 { 

				lappend com(localcfg,service,httpd,list) $vhost,$directorio,$location,$directive
				lappend com(localcfg,service,httpd,context,$vhost,$directorio,$location,$directive)  " "

				}

				List {
					lappend com(localcfg,service,httpd,list) $vhost,$directorio,$location,$directive 
					regsub -all {\\\"} [string trim  [string range [string trim $dato] [string length $fdato] end ]] {"} tmp
					lappend com(localcfg,service,httpd,context,$vhost,$directorio,$location,$directive)  $tmp
				}

				List2 {
					if "[lsearch -exact $com(localcfg,service,httpd,list) $vhost,$directorio,$location,$directive] == -1" {
						lappend com(localcfg,service,httpd,list) $vhost,$directorio,$location,$directive 
						# Esto es para no contar dos veces
					}
					regsub -all {\"} [string trim  [string range [string trim $dato] [string length $fdato] end ]] {"} tmp
					regsub -all {\\\".*\\\"+} $tmp {"&"} tmp2
					foreach element $tmp2 {
						lappend com(localcfg,service,httpd,context,$vhost,$directorio,$location,$directive)  $element 
					}
				}

				Choice {

				lappend com(localcfg,service,httpd,list) $vhost,$directorio,$location,$directive
				set com(localcfg,service,httpd,context,$vhost,$directorio,$location,$directive)  [string tolower [lrange $dato 1 end]]


				}
				UNKNOWN {
				
				#If it was not recognized maybe it was a directive that contains spaces
				# Like allow from, etc...
				set minus [string tolower $dato ]
				set i 0
				set success 0

				foreach dir { {allow\ from\ env=} {deny\ from\ env=} {allow\ from} {deny\ from} } {

				if [regexp $dir $minus] {
					set directive [lindex { allow_from_env= deny_from_env= allow_from deny_from }  $i]
					if "[lsearch -exact $com(localcfg,service,httpd,list) $vhost,$directorio,$location,$directive] == -1" {

							lappend com(localcfg,service,httpd,list) $vhost,$directorio,$location,$directive 
							}
				regsub -all {\\\"} [string trim  [string range [string trim $dato] [string length $directive] end ]] {"} tmp
				lappend com(localcfg,service,httpd,context,$vhost,$directorio,$location,$directive)  $tmp
				set success 1
				break
				}
				incr i
				}
				if [expr ![string compare [lindex $minus 0] include]] {CnfFilesParser [file join $com(globals,inputdir) [lindex $minus 1]]; set success 1 }
				if [expr ! $success ] {
				append com(localcfg,service,httpd,context,$vhost,$directorio,$location,unknown) "$dato \n"
				}
				}

			}


		}
}
}

close $fich



}



#Habra que definir create cuando tengaos uno nuevo, clean para hacer una especie de reset (util?)
# Y delete

proc Create.vhost {vhost} {

global com


set i 2
while [expr  [lsearch -exact $com(data,vhost,list) $vhost] != -1] {
set vhost "[lindex [split $vhost (] 0]\($i\)"
incr i
}

lappend com(data,vhost,list) $vhost

set com(data,vhost,name,$vhost,dirs,list)  ""
set com(data,vhost,name,$vhost,location,list)  ""

for "set i 0" {$i < [llength $com(layout,scope,vhost,part,list)]} "incr i" {

	foreach title $com(layout,scope,vhost,part,$i,titles) {

		foreach directiva $com(layout,scope,vhost,part,$i,title,$title,directives) { 
		set directiva [lindex $directiva 1]	
		set com(localcfg,service,httpd,context,$vhost,,,$directiva) "" }
	}
	}
return $vhost
}

proc Create.sconfig {} {

global com


set com(data,sconfig,dirs,list)  ""
set com(data,sconfig,location,list)  ""

for "set i 0" {$i < [llength $com(layout,scope,sconfig,part,list)]} "incr i" {

	foreach title $com(layout,scope,sconfig,part,$i,titles) {

	foreach directiva  $com(layout,scope,sconfig,part,$i,title,$title,directives) {
		set directiva [lindex $directiva 1]
		set com(localcfg,service,httpd,context,,,,$directiva) ""

	}
	}
	}

}


proc Create.dir {vhost dir} {

global com


lappend com(data,vhost,name,$vhost,dirs,list) $dir


for "set i 0" {$i < [llength $com(layout,scope,dirs,part,list)]} "incr i" {

	foreach title $com(layout,scope,dirs,part,$i,titles) {

	foreach directiva  $com(layout,scope,dirs,part,$i,title,$title,directives) {
		set directiva [lindex $directiva 1]
		set com(localcfg,service,httpd,context,$vhost,$dir,,$directiva) ""}
	}
	}


}

proc Create.location {vhost location} {

global com


lappend com(data,vhost,name,$vhost,location,list) $location


for "set i 0" {$i < [llength $com(layout,scope,location,part,list)]} "incr i" {

	foreach title $com(layout,scope,location,part,$i,titles) {

	foreach directiva  $com(layout,scope,location,part,$i,title,$title,directives) {
	set directiva [lindex $directiva 1]	
	set com(localcfg,service,httpd,context,$vhost,,$location,$directiva) ""
	
	}
	}
	}


}




proc SaveCnfFilesTmpl.all {} {

global com

#Aqui tendrian que poner los path a los ficheros de salida

set path [pwd]


#====================
# Write Config Files
#====================

# Server Config

ReadCnfScope sconfig
ReadCnfScope vhost
ReadCnfScope location
ReadCnfScope dirs

cd $com(globals,outputdir)
exec ci -mautobackup -t-httpd.conf -l httpd.conf >/dev/null 2>/dev/null
cd $path
set myfile [open $path/tmpl/httpd.conf.tmpl r]
catch [file delete [file join $com(globals,outputdir) httpd.conf]]]
set output [open [file join $com(globals,outputdir) httpd.conf] a+]

while {[expr ![eof $myfile]]} {
	gets $myfile dato
	if {[regexp "^ *#+" $dato] || [regexp "^ *$" $dato]} {puts $output $dato} else {

	set sw [lindex $dato 0]
	switch $sw {

	d {
		set directive [string tolower [lindex $dato 1]]
		SaveCnfFilesTmpl.directive  $output $directive localcfg,service,httpd,context,,,,

		}

	i {
	set insert [string tolower [lindex $dato 1]]
	SaveCnfFilesTmpl.$insert	$output {}
	}

	}


	}

	}





close $myfile
close $output

cd $com(globals,outputdir)
exec ci -mautobackup -t-srm.conf -l srm.conf >/dev/null 2>/dev/null
cd $path
set myfile [open $path/tmpl/srm.conf.tmpl r]
catch [file delete [file join $com(globals,outputdir) srm.conf]]
set output [open [file join $com(globals,outputdir) srm.conf ] a+]

while {[expr ![eof $myfile]]} {
	gets $myfile dato
	if {[regexp "^ *#+" $dato] || [regexp "^ *$" $dato]} {puts $output $dato} else {

	set sw [lindex $dato 0]
	switch $sw {

	d {
		set directive [string tolower [lindex $dato 1]]
		SaveCnfFilesTmpl.directive  $output $directive localcfg,service,httpd,context,,,,

		}

	i {
	set insert [string tolower [lindex $dato 1]]
	SaveCnfFilesTmpl.$insert	$output {}
	}

	}


	}

	}





close $myfile
close $output

cd $com(globals,outputdir)
exec ci -mautobackup -t-access.conf -l access.conf >/dev/null 2>/dev/null
cd $path
set myfile [open $path/tmpl/access.conf.tmpl r]
catch [file delete [file join $com(globals,outputdir) access.conf]]
set output [open [file join $com(globals,outputdir) access.conf] a+]

while {[expr ![eof $myfile]]} {
	gets $myfile dato
	if {[regexp "^ *#+" $dato] || [regexp "^ *$" $dato]} {puts $output $dato} else {

	set sw [lindex $dato 0]
	switch $sw {

	d {
		set directive [string tolower [lindex $dato 1]]
		SaveCnfFilesTmpl.directive  $output $directive localcfg,service,httpd,context,,,,

		}

	i {
	set insert [string tolower [lindex $dato 1]]
	SaveCnfFilesTmpl.$insert  $output {}
	}

	}


	}

	}





close $myfile
close $output


}





proc SaveCnfFilesTmpl.directory {output vhost} {


global com


set scope dirs
foreach directory $com(data,vhost,name,$vhost,$scope,list) {

puts $output " "
puts $output "<directory $directory>"
puts $output " "

set l  [llength $com(layout,scope,$scope,part,list)]

for "set part 0" {$part < $l} "incr part" {	    


foreach title "$com(layout,scope,$scope,part,$part,titles)" {

set written 0

foreach pair "$com(layout,scope,$scope,part,$part,title,$title,directives)" {

                set module [lindex $pair 0]
		set directive [lindex $pair 1]

		set written [expr $written | [SaveCnfFilesTmpl.directive $output $directive localcfg,service,httpd,context,$vhost,$directory,,]]
		
}

if $written {
puts $output "# $title"
puts $output ""}

}

}
puts $output " "
puts $output "</directory>"
puts $output " "
}


}



proc SaveCnfFilesTmpl.location {output vhost} {


global com


set scope location
foreach location $com(data,vhost,name,$vhost,$scope,list) {

puts $output " "
puts $output "<location $location>"
puts $output " "

set l  [llength $com(layout,scope,$scope,part,list)]

for "set part 0" {$part < $l} "incr part" {	    


foreach title "$com(layout,scope,$scope,part,$part,titles)" {


set written 0

foreach pair "$com(layout,scope,$scope,part,$part,title,$title,directives)" {

                set module [lindex $pair 0]
		set directive [lindex $pair 1]

		set written [expr $written | [SaveCnfFilesTmpl.directive $output $directive localcfg,service,httpd,context,$vhost,,$location,]]
		
}

if $written {
puts $output "# $title"
puts $output ""}

}

}

puts $output "</location>"
}


}




proc SaveCnfFilesTmpl.directive {output directive context} {

global com


                set type_dir UNKNOWN 
		set directive [string tolower $directive]
                foreach type { List List2 String File Directory Number Boolean Boolean2 Email Choice Address unknown} {

		set result [lsearch -exact $com(dir-types-lowercase,$type) $directive]
		if [expr $result != -1] { set directive [lindex $com(dir-types,$type) $result] ; set type_dir $type;
						break}

		}

		if "[expr [string compare $type_dir UNKNOWN] !=0 ]" {
		
		set value $com($context$directive)
		switch $directive {
		allow_from {set directive "allow\ from"}
		deny_from {set directive "deny\ from"}
		allow_from_env= {set directive "allow\ from\ env="}
		deny_from_env= {set directive "deny\ from\ env="}
		}
		
		if "[string compare $value  {} ] == 0 | [string compare	$value {{}}] ==0" { return 0
		} else {
		switch $type_dir {	


		List2	{
			puts -nonewline $output "$directive "
				foreach element $value {
				regsub -all {\\\"} $element {"} kk
				puts -nonewline $output "$kk "
				} 
			puts $output " "}
		unknown {
			puts $output $value
		}
		default  {
				foreach element $value {
				puts -nonewline $output "$directive "
				regsub -all {\\\"} $element {"} kk
				puts $output $kk
				} 
				}
				
		}
		return 1
	}
	}
return 0
}


proc SaveCnfFilesTmpl.vhosts {output dummy} {


global com


set scope vhost
foreach vhost $com(data,vhost,list) {

puts $output " "
puts $output "<VirtualHost [lindex [split $vhost (] 0]>"
puts $output " "

set l  [llength $com(layout,scope,$scope,part,list)]

for "set part 0" {$part < $l} "incr part" {	    


foreach title "$com(layout,scope,$scope,part,$part,titles)" {

set written 0

foreach pair "$com(layout,scope,$scope,part,$part,title,$title,directives)" {

                set module [lindex $pair 0]
		set directive [lindex $pair 1]

		set written [expr $written | [SaveCnfFilesTmpl.directive $output $directive localcfg,service,httpd,context,$vhost,,,]]
		
}

if $written {
puts $output "# $title"
puts $output ""}

}

}



SaveCnfFilesTmpl.directory $output $vhost 



puts $output " "
puts $output "</VirtualHost>"
puts $output " "
}


}

proc SaveCnfFilesTmpl.vhostsperfile {output dummy} {


global com


set scope vhost
foreach vhost $com(data,vhost,list) {


catch [file delete [file join $com(globals,outputdir) $vhost.conf]]
set output2 [open [file join $com(globals,outputdir) $vhost.conf] a+]

puts $output2 " "
puts $output2 "<VirtualHost [lindex [split $vhost (] 0]>"
puts $output2 " "

set l  [llength $com(layout,scope,$scope,part,list)]

for "set part 0" {$part < $l} "incr part" {	    


foreach title "$com(layout,scope,$scope,part,$part,titles)" {

set written 0

foreach pair "$com(layout,scope,$scope,part,$part,title,$title,directives)" {

                set module [lindex $pair 0]
		set directive [lindex $pair 1]

		set written [expr $written | [SaveCnfFilesTmpl.directive $output2 $directive localcfg,service,httpd,context,$vhost,,,]]
		
}

if $written {
puts $output2 "# $title"
puts $output2 ""}

}

}



SaveCnfFilesTmpl.directory $output2 $vhost



puts $output2 " "
puts $output2 "</VirtualHost>"
puts $output2 " "
close $output2
puts $output "include $vhost.conf"
}


}


