##############################################################################
#
# Copyright (C) 1998 Daniel Lopez
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

proc Reset {} {

global com
global widget

foreach scope {sconfig vhost dirs location} {

Reset.scope $scope

}

unset com

}


proc Reset.scope { scp } {

global com


for "set i 0" {$i < [llength $com(layout,scope,$scp,part,list)]} "incr i" {

	Reset.part $scp $i

	}

}


proc Reset.part {  scope part } {

global widget

set temp $scope

append temp _cv

destroy  $widget($temp).p_$part


}


proc busy {cmds} {
    global errorInfo
    
        set busy {.app .root}
	set list [winfo children .]
	while {$list != ""} {
	set next {}
	foreach w $list {
	set class [winfo class $w]
	set cursor [lindex	[$w config -cursor] 4]
	if {[winfo toplevel $w] == $w || $cursor != ""} {
	lappend busy [list $w $cursor]
	}
	set next [concat $next [winfo	children $w]]
        }
	set list $next
	}
	
	foreach w $busy {
	catch {[lindex $w 0] config -cursor watch}
	}
	
	update idletasks
	
	set error [catch {uplevel eval	[list $cmds]} result]
	set ei $errorInfo
	
	foreach w $busy {
	catch {[lindex $w 0] config -cursor [lindex $w 1]}
	}
	if $error {
	error $result $ei
	} else {
	return $result
	}
	}
						     
						     
