##############################################################################
#
# Copyright (C) 1998 Daniel Lopez
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.



##############################################################################
#############################################################################
# Visual Tcl v1.11 Project
#

#################################
# GLOBAL VARIABLES
#
global visible; set visible {1}
global widget; 
    set widget(dirs) {.top17.fra22}
    set widget(dirs,dirs_list) {.top17.fra22.lis18}
    set widget(dirs,dirs_sy) {.top17.fra22.scr19}
    set widget(dirs,parts_list) {.top17.fra22.lis17}
    set widget(dirs,parts_sy) {.top17.fra22.scr18}
    set widget(dirs,vhost_list) {.top17.fra22.lis22}
    set widget(dirs,vhost_sy) {.top17.fra22.scr23}
    set widget(dirs_cv) {.top17.fra22.can26}
    set widget(dirs_cv_sy) {.top17.fra22.scr27}
    set widget(location) {.top17.fra23}
    set widget(location,location_list) {.top17.fra23.lis19}
    set widget(location,location_sy) {.top17.fra23.scr22}
    set widget(location,parts_list) {.top17.fra23.lis17}
    set widget(location,parts_sy) {.top17.fra23.scr20}
    set widget(location,vhost_list) {.top17.fra23.lis18}
    set widget(location,vhost_sy) {.top17.fra23.scr21}
    set widget(location_cv) {.top17.fra23.can23}
    set widget(location_cv_sy) {.top17.fra23.scr25}
    set widget(rev,.top17) {top_com}
    set widget(rev,.top17.fra17) {sconfig}
    set widget(rev,.top17.fra17.can19) {sconfig_cv}
    set widget(rev,.top17.fra17.fra18.lis19) {sconfig,parts_list}
    set widget(rev,.top17.fra17.fra18.scr20) {sconfig,parts_sy}
    set widget(rev,.top17.fra17.scr20) {sconfig_sy}
    set widget(rev,.top17.fra18) {servers}
    set widget(rev,.top17.fra18.can23) {vhost_cv}
    set widget(rev,.top17.fra18.fra21.lis22) {vhost,vhost_list}
    set widget(rev,.top17.fra18.fra21.scr23) {vhost,vhost_sy}
    set widget(rev,.top17.fra18.fra27.lis28) {vhost,parts_list}
    set widget(rev,.top17.fra18.fra27.scr29) {vhost,parts_sy}
    set widget(rev,.top17.fra18.scr24) {vhost_cv_sy}
    set widget(rev,.top17.fra19) {sconfig}
    set widget(rev,.top17.fra22) {dirs}
    set widget(rev,.top17.fra22.can26) {dirs_cv}
    set widget(rev,.top17.fra22.lis17) {dirs,parts_list}
    set widget(rev,.top17.fra22.lis18) {dirs,dirs_list}
    set widget(rev,.top17.fra22.lis22) {dirs,vhost_list}
    set widget(rev,.top17.fra22.scr18) {dirs,parts_sy}
    set widget(rev,.top17.fra22.scr19) {dirs,dirs_sy}
    set widget(rev,.top17.fra22.scr23) {dirs,vhost_sy}
    set widget(rev,.top17.fra22.scr27) {dirs_cv_sy}
    set widget(rev,.top17.fra23) {location}
    set widget(rev,.top17.fra23.can23) {location_cv}
    set widget(rev,.top17.fra23.lis17) {location,parts_list}
    set widget(rev,.top17.fra23.lis18) {location,vhost_list}
    set widget(rev,.top17.fra23.lis19) {location,location_list}
    set widget(rev,.top17.fra23.scr20) {location,parts_sy}
    set widget(rev,.top17.fra23.scr21) {location,vhost_sy}
    set widget(rev,.top17.fra23.scr22) {location,location_sy}
    set widget(rev,.top17.fra23.scr25) {location_cv_sy}
    set widget(rev,.top17.fra26) {sconfig}
    set widget(rev,.top18) {top_remote}
    set widget(rev,.top18.ent17) {weblist_port}
    set widget(rev,.top18.ent29) {weblist_address}
    set widget(rev,.top18.lis19) {weblist}
    set widget(rev,.top18.scr20) {weblistscrolly}
    set widget(rev,.top18.tex28) {weblist_text}
    set widget(rev,.top19.but22) {top_bt_localcfg}
    set widget(sconfig) {.top17.fra17}
    set widget(sconfig,parts_list) {.top17.fra17.fra18.lis19}
    set widget(sconfig,parts_sy) {.top17.fra17.fra18.scr20}
    set widget(sconfig_cv) {.top17.fra17.can19}
    set widget(sconfig_sy) {.top17.fra17.scr20}
    set widget(servers) {.top17.fra18}
    set widget(top_bt_localcfg) {.top19.but22}
    set widget(top_com) {.top17}
    set widget(top_remote) {.top18}
    set widget(vhost,parts_list) {.top17.fra18.fra27.lis28}
    set widget(vhost,parts_sy) {.top17.fra18.fra27.scr29}
    set widget(vhost,vhost_list) {.top17.fra18.fra21.lis22}
    set widget(vhost,vhost_sy) {.top17.fra18.fra21.scr23}
    set widget(vhost_cv) {.top17.fra18.can23}
    set widget(vhost_cv_sy) {.top17.fra18.scr24}
    set widget(weblist) {.top18.lis19}
    set widget(weblist_address) {.top18.ent29}
    set widget(weblist_port) {.top18.ent17}
    set widget(weblist_text) {.top18.tex28}
    set widget(weblistscrolly) {.top18.scr20}

#################################
# USER DEFINED PROCEDURES
#
proc init {argc argv} {
global widget

set PATH [pwd]
source "$PATH/lib/icons.tcl"

InitIcon "$PATH/icons" "file"
InitIcon "$PATH/icons" "add"
InitIcon "$PATH/icons" "del"
InitIcon "$PATH/icons" "edit"
InitIcon "$PATH/icons" "help"
InitIcon "$PATH/icons" "logo2"

option add *Canvas.background [. cget -background] 


}

init $argc $argv


proc {InitIcon} {path name} {
global com

image create photo "images(images,$name)" -file "$path/$name.gif"
}

proc initsrc {} {

set PATH [pwd]
source "$PATH/lib/balloon.tcl"

source "$PATH/lib/parser.tcl"
source "$PATH/lib/container.tcl"
source "$PATH/lib/dialog.tcl"
source "$PATH/lib/rd_wr.tcl"
source "$PATH/lib/rd_wr_cfg.tcl"
source "$PATH/lib/util.tcl"

}

initsrc

proc {inicia} {} {
global widget
set com() ""
unset com
global com
catch [file delete comanche.log]
set com(globals) ""
set com(globals,errorlog) [open comanche.log a+]
set com(globals,cv_wd) 310
set com(layout,scope,vhost,part,actual) 0
set com(layout,scope,sconfig,part,actual) 0
set com(layout,scope,dirs,part,actual) 0
set com(layout,scope,location,part,actual) 0

set com(data,vhost,list) ""

set com(data,vhost,name,,dirs,list) ""
set com(data,vhost,name,,location,list) ""

foreach var {sconfig vhost dirs location} {
set com(globals,scope,$var,status) disabled
}

set PATH [pwd]

#source "comconf.tcl"
ReadCfg

ReadModulesDescription "$PATH/ccf"
ReadLayouts "$PATH/ccf/layout_sconfig.ccf"
ReadLayouts "$PATH/ccf/layout_servers.ccf"
ReadLayouts "$PATH/ccf/layout_dirs.ccf"
ReadLayouts "$PATH/ccf/layout_location.ccf"

PurgeAll

CreateAllContainers


UpdatePartList sconfig
UpdatePartList vhost
UpdatePartList dirs
UpdatePartList location

foreach var {com(globals,dirs,vhost) com(globals,dirs,dir) com(globals,dirs,location) com(globals,location,vhost) com(globals,location,dir) com(globals,location,location) com(globals,sconfig,vhost) com(globals,sconfig,dir) com(globals,sconfig,location) com(globals,vhost,vhost) com(globals,vhost,dir) com(globals,vhost,location) } {
set $var {}
}

Create.sconfig

CnfFilesParser [file join $com(globals,inputdir) httpd.conf]
CnfFilesParser [file join $com(globals,inputdir) srm.conf]
CnfFilesParser [file join $com(globals,inputdir) access.conf]

UpdateVhostList 


# Ahora updatamos para que nada mas empezar ya haya algo

$widget(vhost,vhost_list) selection set 0
$widget(vhost,parts_list) selection set 0
$widget(dirs,vhost_list) selection set 0
$widget(dirs,parts_list) selection set 0
$widget(location,vhost_list) selection set 0
$widget(location,parts_list) selection set 0
$widget(sconfig,parts_list) selection set 0


set com(globals,sconfig,vhost) ""
set com(globals,sconfig,dir) ""
set com(globals,sconfig,location) ""

ShowContainer sconfig 0
FillCnfScope sconfig

set com(globals,vhost,vhost) [$widget(vhost,vhost_list) get 0]
set com(globals,vhost,dir) ""
set com(globals,vhost,location) ""

if [expr [$widget(vhost,vhost_list) size] != 0] {

ShowContainer vhost 0
FillCnfScope vhost


}

set com(globals,dirs,vhost) ""

UpdateDirList ""

set com(globals,location,vhost) ""

UpdateLocationList ""

if [expr [$widget(dirs,dirs_list) size] != 0] {
$widget(dirs,dirs_list) selection set 0
set com(globals,dirs,dir) [$widget(dirs,dirs_list) get 0]

ShowContainer dirs 0
FillCnfScope dirs
}

if [expr [$widget(location,location_list) size] != 0] {
$widget(location,location_list) selection set 0
set com(globals,location,location) [$widget(location,location_list) get 0]

ShowContainer location 0
FillCnfScope location

}
}

proc {main} {argc argv} {
global  widget

vTcl:set_balloon $widget(top_bt_localcfg) "Click here to configure a webserver in the local machine"

}

proc {Window} {args} {
global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    wm focusmodel $base passive
    wm geometry $base 200x200+0+0
    wm maxsize $base 804 585
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm withdraw $base
    wm title $base "vt"
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.top17 {base} {
    if {$base == ""} {
        set base .top17
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 580x400+21+61
    wm maxsize $base 804 585
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "COMANCHE"
    frame $base.fra18  -borderwidth 2 -height 75 -relief groove -width 125 
    frame $base.fra18.fra21  -borderwidth 2 -height 75 -relief groove -width 125 
    listbox $base.fra18.fra21.lis22  -exportselection 0 -selectbackground blue4 -selectforeground white  -yscrollcommand {global widget
$widget(vhost,vhost_sy) set} 
    bind $base.fra18.fra21.lis22 <ButtonRelease-1> {
        global widget
global com

if [expr [string compare $com(data,vhost,list) "" ] == 0] {return}

ReadCnfScope vhost

set actual [$widget(vhost,vhost_list) curselection]

set com(globals,vhost,vhost) [$widget(vhost,vhost_list) get $actual]

set com(globals,vhost,dir) ""

$widget(vhost,vhost_list) activate $actual
    
FillCnfScope vhost
    }
    scrollbar $base.fra18.fra21.scr23  -command {$widget(vhost,vhost_list) yview} -orient vert 
    button $base.fra18.fra21.but24  -image images(images,edit) -padx 9 -pady 3 -text Edit 
    button $base.fra18.fra21.but25  -image images(images,del) -padx 9 -pady 3 -text Remove 
    button $base.fra18.fra21.but26   -command {AddVhost
if [ expr [string compare $result {} ] != 0 ]  {  Create.vhost  $result}

UpdateVhostList
}  -image images(images,add) -padx 9 -pady 3 -text Add 
    frame $base.fra18.fra27  -borderwidth 2 -height 75 -relief groove -width 125 
    listbox $base.fra18.fra27.lis28  -exportselection 0 -selectbackground green4 -selectforeground white  -yscrollcommand {global widget
$widget(vhost,parts_sy) set} 
    bind $base.fra18.fra27.lis28 <ButtonRelease-1> {
        global widget
global com

set actual [$widget(vhost,parts_list) curselection]

$widget(vhost,parts_list)  activate $actual


if [expr [string compare $com(data,vhost,list) ""] != 0] {
ShowContainer vhost  $actual } else { ShowBlank vhost $actual}
    }
    scrollbar $base.fra18.fra27.scr29  -command {$widget(vhost,parts_list) yview} -orient vert 
    canvas $base.fra18.can23 -highlightthickness 0 -insertborderwidth 0  -height 264 -insertwidth 0 -scrollregion {0  0  300 1000} -width 377  -yscrollcommand {global widget
$widget(vhost_cv_sy) set} 
    scrollbar $base.fra18.scr24  -command {global widget
$widget(vhost_cv) yview} -orient vert 
    frame $base.fra20  -borderwidth 2 -height 75 -relief groove -width 125 
    radiobutton $base.fra20.che24   -command {global  widget
place forget $widget(servers) 
place forget $widget(dirs)
place forget $widget(location)
place $widget(sconfig) -x 20 -y 60 -width 540 -height 315 -anchor nw -bordermode ignore}  -indicatoron 0 -value sconfig -selectcolor Seagreen2 -text Main  -variable visible
    radiobutton $base.fra20.che25   -command {global widget
place forget $widget(sconfig) 
place forget $widget(dirs)
place forget $widget(location)
place $widget(servers) -x 20 -y 60 -width 540 -height 315 -anchor nw  -bordermode ignore}  -indicatoron 0 -value servers -selectcolor Seagreen2 -text Servers  -variable visible 
    button $base.fra20.but18  -command {global widget
wm withdraw $widget(top_com)
busy Reset} -padx 9 -pady 3  -text Exit 
    button $base.fra20.but19  -command SaveCnfFilesTmpl.all -padx 9 -pady 3 -text Save 
    radiobutton $base.fra20.che21   -command {global widget

#Incluir algo para salvar la configuracion


place forget $widget(sconfig)
place forget $widget(servers)
place forget $widget(location)


place $widget(dirs) -x 20 -y 60 -width 540 -height 315 -anchor nw -bordermode ignore}  -indicatoron 0 -selectcolor Seagreen2 -text Directories  -variable visible 
    radiobutton $base.fra20.che22   -command {global widget

#Incluir algo para salvar la configuracion


place forget $widget(sconfig)
place forget $widget(servers)
place forget $widget(dirs)


place $widget(location) -x 20 -y 60 -width 540 -height 315 -anchor nw -bordermode ignore}  -indicatoron 0 -value location -selectcolor Seagreen2  -text Location -variable visible 
    frame $base.fra17  -borderwidth 2 -height 75 -relief groove -width 125 
    canvas $base.fra17.can19 -highlightthickness 0  -insertborderwidth 0 -height 2640 -insertwidth 0 -scrollregion {0 0 300 2000} -width 377  -yscrollcommand {global widget
$widget(sconfig_sy) set} 
    frame $base.fra17.can19.module2  -height 4000 -width 200 
    scrollbar $base.fra17.scr20  -command {global widget
$widget(sconfig_cv) yview} -orient vert  -takefocus 0 
    frame $base.fra17.fra18  -borderwidth 2 -height 75 -relief groove -width 125 
    listbox $base.fra17.fra18.lis19  -exportselection 0 -selectbackground green4 -selectforeground white  -yscrollcommand {global widget
$widget(sconfig,parts_sy) set} 
    bind $base.fra17.fra18.lis19 <ButtonRelease-1> {
        global widget
global com

set actual [$widget(sconfig,parts_list) curselection]

$widget(sconfig,parts_list) activate $actual

#set temp mod_
#append temp [lindex $com(data,scope,sconfig,modules,list) $actual]
#ShowContainer sconfig [lindex $com(layout,scope,sconfig,part,list) $actual]
ShowContainer sconfig $actual
    }
    scrollbar $base.fra17.fra18.scr20  -command {$widget(sconfig,parts_list) yview} -orient vert 
    label $base.fra17.lab17  -borderwidth 1 -image images(images,logo2) -text label 
    frame $base.fra22  -borderwidth 2 -height 75 -relief groove -width 125 
    listbox $base.fra22.lis18  -exportselection 0 -selectbackground red4 -selectforeground White  -yscrollcommand {global widget
$widget(dirs,dirs_sy) set} 
    bind $base.fra22.lis18 <ButtonRelease-1> {
        global widget
global com
if [expr [$widget(dirs,dirs_list) size]  == 0] {return}
ReadCnfScope dirs

set actual [$widget(dirs,dirs_list) curselection]

set com(globals,dirs,dir) [$widget(dirs,dirs_list) get $actual]


$widget(dirs,dirs_list) activate $actual
    
FillCnfScope dirs
    }
    scrollbar $base.fra22.scr19  -command {$widget(dirs,dirs_list) yview} -orient vert 
    button $base.fra22.but20   -command {
set vhost $com(globals,dirs,vhost)
AddDir $vhost
if [ expr [string compare $result {} ] != 0 ]  {  Create.dir $vhost $result}

UpdateDirList $vhost
}  -image images(images,add) -padx 9 -pady 3 -text button 
    button $base.fra22.but21  -image images(images,del) -padx 9 -pady 3 -text button 
    listbox $base.fra22.lis22  -exportselection 0 -selectbackground blue4 -selectforeground White  -yscrollcommand {global widget
$widget(dirs,vhost_sy) set} 
    bind $base.fra22.lis22 <ButtonRelease-1> {
        global widget
global com

ReadCnfScope dirs

set actual [$widget(dirs,vhost_list) curselection]

set com(globals,dirs,vhost) [$widget(dirs,vhost_list) get $actual]

if "$actual == 0" {set com(globals,dirs,vhost) ""}

$widget(dirs,vhost_list) activate $actual


UpdateDirList $com(globals,dirs,vhost)
$widget(dirs,dirs_list) selection set 0
$widget(dirs,dirs_list) activate 0
set com(globals,dirs,dir) [$widget(dirs,dirs_list) get 0]



if [expr [$widget(dirs,dirs_list) size] !=0] {
FillCnfScope dirs } else {
ShowBlank dirs [$widget(dirs,parts_list) curselection]
}
    }
    scrollbar $base.fra22.scr23  -command {$widget(dirs,vhost_list) yview} -orient vert 
    button $base.fra22.but24  -image images(images,edit) -padx 9 -pady 3 -text button 
    canvas $base.fra22.can26 -highlightthickness 0  -insertborderwidth 0  -height 264 -scrollregion {0  0  300 1000} -width 377  -yscrollcommand {global widget
$widget(dirs_cv_sy) set} 
    scrollbar $base.fra22.scr27  -command {global widget
$widget(dirs_cv) yview} -orient vert 
    listbox $base.fra22.lis17  -exportselection 0 -selectbackground green4 -selectforeground white  -yscrollcommand {global widget
$widget(dirs,parts_sy) set} 
    bind $base.fra22.lis17 <ButtonRelease-1> {
        global widget
global com

set actual [$widget(dirs,parts_list) curselection]


$widget(dirs,parts_list)  activate $actual

if [expr [$widget(dirs,dirs_list) size] != 0] {
ShowContainer dirs  $actual} else {
ShowBlank dirs $actual
}
    }
    scrollbar $base.fra22.scr18  -command {$widget(dirs,parts_list) yview} -orient vert 
    frame $base.fra23  -borderwidth 2 -height 75 -relief groove -width 125 
    listbox $base.fra23.lis17  -exportselection 0 -selectbackground green4 -selectforeground WHITE  -yscrollcommand {global widget
$widget(location,parts_sy) set} 
    bind $base.fra23.lis17 <ButtonRelease-1> {
        global widget
global com

set actual [$widget(location,parts_list) curselection]


$widget(location,parts_list)  activate $actual

    if [expr [$widget(location,location_list) size] != 0] {
ShowContainer location  $actual} else {
ShowBlank location $actual
}
    }
    listbox $base.fra23.lis18  -exportselection 0 -selectbackground blue4 -selectforeground WHITE  -yscrollcommand {global widget
$widget(location,vhost_sy) set} 
    bind $base.fra23.lis18 <ButtonRelease-1> {
        global widget
global com

ReadCnfScope location

set actual [$widget(location,vhost_list) curselection]

set com(globals,location,vhost) [$widget(location,vhost_list) get $actual]

if "$actual == 0" {set com(globals,location,vhost) ""}

$widget(location,vhost_list) activate $actual


UpdateLocationList $com(globals,location,vhost)
$widget(location,location_list) selection set 0
$widget(location,location_list) activate 0
set com(globals,location,location) [$widget(location,location_list) get 0]

if [expr [$widget(location,location_list) size] !=0] {
FillCnfScope location } else {
ShowBlank location [$widget(location,parts_list) curselection]
}
    }
    listbox $base.fra23.lis19  -exportselection 0 -selectbackground red4 -selectforeground white  -yscrollcommand {global widget
$widget(location,location_sy) set} 
    bind $base.fra23.lis19 <ButtonRelease-1> {
        global widget
global com
if [expr [$widget(location,location_list) size]  == 0] {return}
ReadCnfScope location

set actual [$widget(location,location_list) curselection]

set com(globals,location,location) [$widget(location,location_list) get $actual]


$widget(location,location_list) activate $actual
    
FillCnfScope location
    }
    scrollbar $base.fra23.scr20  -command {$widget(location,parts_list) yview} -orient vert 
    scrollbar $base.fra23.scr21  -command {$widget(dirs,vhost_list) yview} -orient vert 
    scrollbar $base.fra23.scr22  -command {$widget(location,location_list) yview} -orient vert 
    canvas $base.fra23.can23  -highlightthickness 0 -insertborderwidth 0  -height 264 -width 377  -yscrollcommand {global widget
$widget(location_cv_sy) set} 
    scrollbar $base.fra23.scr25  -command {$widget(location_cv) yview} -orient vert 
    button $base.fra23.but26   -command {
set vhost $com(globals,location,vhost)
AddLocation $vhost
if [ expr [string compare $result {} ] != 0 ]  {  Create.location $vhost $result}

UpdateLocationList $vhost
}  -image images(images,add) -padx 9 -pady 3 -text button 
    button $base.fra23.but27  -image images(images,del) -padx 9 -pady 3 -text button 
    button $base.fra23.but28  -image images(images,edit) -padx 9 -pady 3 -text button 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.fra18.fra21  -x 5 -y 10 -width 185 -height 150 -anchor nw -bordermode ignore 
    place $base.fra18.fra21.lis22  -x 5 -y 15 -width 143 -height 76 -anchor nw -bordermode ignore 
    place $base.fra18.fra21.scr23  -x 155 -y 15 -width 17 -height 75 -anchor nw -bordermode ignore 
    place $base.fra18.fra21.but24  -x 120 -y 105 -anchor nw -bordermode ignore 
    place $base.fra18.fra21.but25  -x 65 -y 105 -anchor nw -bordermode ignore 
    place $base.fra18.fra21.but26  -x 10 -y 105 -anchor nw -bordermode ignore 
    place $base.fra18.fra27  -x 5 -y 170 -width 185 -height 140 -anchor nw -bordermode ignore 
    place $base.fra18.fra27.lis28  -x 10 -y 10 -width 138 -height 121 -anchor nw -bordermode ignore 
    place $base.fra18.fra27.scr29  -x 155 -y 10 -width 17 -height 120 -anchor nw -bordermode ignore 
    place $base.fra18.can23  -x 200 -y 10 -width 310 -height 302 -anchor nw -bordermode ignore 
    place $base.fra18.scr24  -x 515 -y 10 -width 17 -height 300 -anchor nw -bordermode ignore 
    place $base.fra20  -x 20 -y 10 -width 540 -height 45 -anchor nw -bordermode ignore 
    place $base.fra20.che24  -x 10 -y 10 -width 41 -height 27 -anchor nw -bordermode ignore
    place $base.fra20.che25  -x 60 -y 10 -width 61 -height 27 -anchor nw -bordermode ignore 
    place $base.fra20.but18  -x 475 -y 10 -width 48 -height 27 -anchor nw -bordermode ignore 
    place $base.fra20.but19  -x 415 -y 10 -width 51 -height 26 -anchor nw -bordermode ignore 
    place $base.fra20.che21  -x 130 -y 10 -width 73 -height 27 -anchor nw -bordermode ignore 
    place $base.fra20.che22  -x 210 -y 10 -width 58 -height 27 -anchor nw -bordermode ignore 
    place $base.fra17.can19  -x 200 -y 10 -width 310 -height 302 -anchor nw -bordermode ignore 
    place $base.fra17.scr20  -x 515 -y 10 -width 17 -height 300 -anchor nw -bordermode ignore 
    place $base.fra17.fra18  -x 5 -y 90 -width 185 -height 220 -anchor nw -bordermode ignore 
    place $base.fra17.fra18.lis19  -x 10 -y 10 -width 138 -height 201 -anchor nw -bordermode ignore 
    place $base.fra17.fra18.scr20  -x 155 -y 10 -width 17 -height 200 -anchor nw -bordermode ignore 
    place $base.fra17.lab17  -x 5 -y 10 -width 181 -height 77 -anchor nw -bordermode ignore 
    place $base.fra22  -x 20 -y 60 -width 540 -height 315 -anchor nw -bordermode ignore 
    place $base.fra22.lis18  -x 160 -y 10 -width 338 -height 71 -anchor nw -bordermode ignore 
    place $base.fra22.scr19  -x 510 -y 10 -width 17 -height 70 -anchor nw -bordermode ignore 
    place $base.fra22.but20  -x 5 -y 15 -anchor nw -bordermode ignore 
    place $base.fra22.but21  -x 55 -y 15 -anchor nw -bordermode ignore 
    place $base.fra22.lis22  -x 5 -y 75 -width 128 -height 106 -anchor nw -bordermode ignore 
    place $base.fra22.scr23  -x 135 -y 75 -width 17 -height 105 -anchor nw -bordermode ignore 
    place $base.fra22.but24  -x 105 -y 15 -anchor nw -bordermode ignore 
    place $base.fra22.can26  -x 160 -y 85 -width 340 -height 222 -anchor nw -bordermode ignore 
    place $base.fra22.scr27  -x 510 -y 90 -width 17 -height 215 -anchor nw -bordermode ignore 
    place $base.fra22.lis17  -x 5 -y 190 -width 128 -height 111 -anchor nw -bordermode ignore 
    place $base.fra22.scr18  -x 135 -y 190 -width 17 -height 110 -anchor nw -bordermode ignore 
    place $base.fra23.lis17  -x 5 -y 190 -width 128 -height 111 -anchor nw -bordermode ignore 
    place $base.fra23.lis18  -x 5 -y 75 -width 128 -height 106 -anchor nw -bordermode ignore 
    place $base.fra23.lis19  -x 160 -y 10 -width 338 -height 71 -anchor nw -bordermode ignore 
    place $base.fra23.scr20  -x 135 -y 190 -width 17 -height 110 -anchor nw -bordermode ignore 
    place $base.fra23.scr21  -x 135 -y 75 -width 17 -height 105 -anchor nw -bordermode ignore 
    place $base.fra23.scr22  -x 510 -y 10 -width 17 -height 70 -anchor nw -bordermode ignore 
    place $base.fra23.can23  -x 160 -y 85 -width 340 -height 222 -anchor nw -bordermode ignore 
    place $base.fra23.scr25  -x 510 -y 95 -width 17 -height 205 -anchor nw -bordermode ignore 
    place $base.fra23.but26  -x 5 -y 15 -anchor nw -bordermode ignore 
    place $base.fra23.but27  -x 55 -y 15 -anchor nw -bordermode ignore 
    place $base.fra23.but28  -x 105 -y 15 -anchor nw -bordermode ignore
}

proc vTclWindow.top18 {base} {
    if {$base == ""} {
        set base .top18
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel  
    wm focusmodel $base passive
    wm geometry $base 475x358+-10+84
    wm maxsize $base 804 585
    wm minsize $base 132 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base "COMANCHE REMOTE SITES"
    listbox $base.lis19  -exportselection 0  -yscrollcommand {global widget
$widget(weblistscrolly) set} 
    bind $base.lis19 <ButtonRelease-1> {
        global widget

set actual [$widget(weblist) curselection]
set actual [$widget(weblist) get $actual]

$widget(weblist_text) configure -state normal
$widget(weblist_text) delete 1.0 end
$widget(weblist_text) insert 1.0 $com(webs,$actual,comments)
$widget(weblist_text) configure -state disabled

set actual [$widget(weblist) curselection]
set actual [$widget(weblist) get $actual]


$widget(weblist_address) configure -state normal
$widget(weblist_address) delete 0 end
$widget(weblist_address) insert 0 $com(webs,$actual,address)
$widget(weblist_address) configure -state disabled
    

$widget(weblist_port) configure -state normal
$widget(weblist_port) delete 0 end
$widget(weblist_port) insert 0 $com(webs,$actual,port)
$widget(weblist_port) configure -state disabled
    }
    scrollbar $base.scr20  -command {$widget(weblist) yview} -orient vert 
    entry $base.ent29  -state disabled 
    label $base.lab30  -borderwidth 1 -relief raised -text Comments: 
    label $base.lab31  -borderwidth 1 -relief raised -text Address/Port: 
    text $base.tex28  -state disabled 
    entry $base.ent17  -state disabled 
    button $base.but18  -image images(images,add) -padx 9 -pady 3 -text Add 
    button $base.but19  -image images(images,del) -padx 9 -pady 3 -text Delete 
    button $base.but20  -padx 9 -pady 3 -text Configure 
    button $base.but21  -image images(images,edit) -padx 9 -pady 3 -text Edit 
    button $base.but22  -image images(images,help) -padx 9 -pady 3 -text Help 

    ###################
    # SETTING GEOMETRY
    ###################
    place $base.lis19  -x 10 -y 15 -width 128 -height 186 -anchor nw -bordermode ignore 
    place $base.scr20  -x 140 -y 15 -width 17 -height 185 -anchor nw -bordermode ignore 
    place $base.ent29  -x 310 -y 25 -width 116 -height 19 -anchor nw -bordermode ignore 
    place $base.lab30  -x 175 -y 60 -width 286 -height 22 -anchor nw -bordermode ignore 
    place $base.lab31  -x 175 -y 25 -width 121 -height 22 -anchor nw -bordermode ignore 
    place $base.tex28  -x 175 -y 90 -width 286 -height 108 -anchor nw -bordermode ignore 
    place $base.ent17  -x 430 -y 25 -width 26 -height 19 -anchor nw -bordermode ignore 
    place $base.but18  -x 15 -y 215 -width 46 -height 26 -anchor nw -bordermode ignore 
    place $base.but19  -x 65 -y 215 -width 42 -height 26 -anchor nw -bordermode ignore 
    place $base.but20  -x 175 -y 215 -anchor nw -bordermode ignore 
    place $base.but21  -x 110 -y 215 -anchor nw -bordermode ignore 
    place $base.but22  -x 280 -y 215 -anchor nw -bordermode ignore 
}

proc vTclWindow.top19 {base} {
    if {$base == ""} {
        set base .top19
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel 

    wm focusmodel $base passive
    wm geometry $base 254x142+288+149
    wm maxsize $base 804 585
    wm minsize $base 104 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "COMANCHE Main menu"
    button $base.but22 \
        \
        -command {global widget
vTclWindow$widget(top_com) ""
wm deiconify $widget(top_com)
busy inicia} \
        -text {Local Configuration} 
    button $base.but19 \
        -text About -command {
tk_messageBox -icon info -default ok -message "Comanche. (c)Daniel Lopez 1998. Comanche is part of the Apache GUI project
See http://butler.disa.mil/ApacheConfigClient 
or http://www.esi.us.es/~ridruejo/gui for details " -title Info -type ok
}
    label $base.lab20 \
        -borderwidth 1 -image images(images,logo2) -text label 
    button $base.but18 \
        -command exit -text {Exit} 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.but22 \
        -in .top19 -anchor center -expand 0 -fill x -side top 
    pack $base.but19 \
        -in .top19 -anchor center -expand 0 -fill x -side top 
    pack $base.lab20 \
        -in .top19 -anchor center -expand 0 -fill both -side top 
    pack $base.but18 \
        -in .top19 -anchor center -expand 0 -fill x -side top 
}

Window show .
Window show .top19

main $argc $argv
